org.apache.maven.artifact.manager

## Interface WagonManager

- All Known Implementing Classes:
    DefaultWagonManager

      public interface WagonManager

  Manages Wagon related operations in Maven.
  Version:
    $Id: WagonManager.java 798706 2009-07-28 20:50:02Z brett $
  Author:
    Michal Maczka

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ROLE`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAuthenticationInfo(java.lang.String repositoryId, java.lang.String username, java.lang.String password, java.lang.String privateKey, java.lang.String passphrase)`
    `void` | `addConfiguration(java.lang.String repositoryId, Xpp3Dom configuration)` Set the configuration for a repository
    `void` | `addMirror(java.lang.String id, java.lang.String mirrorOf, java.lang.String url)`
    `void` | `addPermissionInfo(java.lang.String repositoryId, java.lang.String filePermissions, java.lang.String directoryPermissions)`
    `void` | `addProxy(java.lang.String protocol, java.lang.String host, int port, java.lang.String username, java.lang.String password, java.lang.String nonProxyHosts)`
    `void` | `getArtifact(Artifact artifact, ArtifactRepository repository)`
    `void` | `getArtifact(Artifact artifact, java.util.List remoteRepositories)`
    `void` | `getArtifactMetadata(ArtifactMetadata metadata, ArtifactRepository remoteRepository, java.io.File destination, java.lang.String checksumPolicy)`
    `void` | `getArtifactMetadataFromDeploymentRepository(ArtifactMetadata metadata, ArtifactRepository remoteRepository, java.io.File file, java.lang.String checksumPolicyWarn)`
    `AuthenticationInfo` | `getAuthenticationInfo(java.lang.String id)`
    `ArtifactRepository` | `getMirrorRepository(ArtifactRepository repository)`
    `ProxyInfo` | `getProxy(java.lang.String protocol)`
    `Wagon` | `getWagon(Repository repository)` Get a Wagon provider for the provided repository.
    `Wagon` | `getWagon(java.lang.String protocol)` Deprecated. prone to errors. use `getWagon(Repository)` instead.
    `boolean` | `isOnline()`
    `void` | `putArtifact(java.io.File source, Artifact artifact, ArtifactRepository deploymentRepository)`
    `void` | `putArtifactMetadata(java.io.File source, ArtifactMetadata artifactMetadata, ArtifactRepository repository)`
    `void` | `registerWagons(java.util.Collection wagons, PlexusContainer extensionContainer)`
    `void` | `setDefaultRepositoryPermissions(RepositoryPermissions permissions)`
    `void` | `setDownloadMonitor(TransferListener downloadMonitor)`
    `void` | `setInteractive(boolean interactive)`
    `void` | `setOnline(boolean online)`

- - ### Field Detail

    - #### ROLE

          static final java.lang.String ROLE

  - ### Method Detail

    - #### getWagon

          Wagon getWagon(java.lang.String protocol)
                         throws UnsupportedProtocolException

      Deprecated. prone to errors. use `getWagon(Repository)` instead.
      Get a Wagon provider that understands the protocol passed as argument. It doesn't configure the Wagon.
      Parameters:
        `protocol` - the protocol the `Wagon` will handle
      Returns:
        the `Wagon` instance able to handle the protocol provided
      Throws:
        `UnsupportedProtocolException` - if there is no provider able to handle the protocol

    - #### getWagon

          Wagon getWagon(Repository repository)
                         throws UnsupportedProtocolException,
                                WagonConfigurationException

      Get a Wagon provider for the provided repository. It will configure the Wagon for that repository.
      Parameters:
        `repository` - the repository
      Returns:
        the `Wagon` instance that can be used to connect to the repository
      Throws:
        `UnsupportedProtocolException` - if there is no provider able to handle the protocol
        `WagonConfigurationException` - if the wagon can't be configured for the repository

    - #### getArtifact

          void getArtifact(Artifact artifact,
                         java.util.List remoteRepositories)
                           throws TransferFailedException,
                                  ResourceDoesNotExistException

      Throws:
        `TransferFailedException`
        `ResourceDoesNotExistException`

    - #### getArtifact

          void getArtifact(Artifact artifact,
                         ArtifactRepository repository)
                           throws TransferFailedException,
                                  ResourceDoesNotExistException

      Throws:
        `TransferFailedException`
        `ResourceDoesNotExistException`

    - #### putArtifact

          void putArtifact(java.io.File source,
                         Artifact artifact,
                         ArtifactRepository deploymentRepository)
                           throws TransferFailedException

      Throws:
        `TransferFailedException`

    - #### putArtifactMetadata

          void putArtifactMetadata(java.io.File source,
                                 ArtifactMetadata artifactMetadata,
                                 ArtifactRepository repository)
                                   throws TransferFailedException

      Throws:
        `TransferFailedException`

    - #### getArtifactMetadata

          void getArtifactMetadata(ArtifactMetadata metadata,
                                 ArtifactRepository remoteRepository,
                                 java.io.File destination,
                                 java.lang.String checksumPolicy)
                                   throws TransferFailedException,
                                          ResourceDoesNotExistException

      Throws:
        `TransferFailedException`
        `ResourceDoesNotExistException`

    - #### getArtifactMetadataFromDeploymentRepository

          void getArtifactMetadataFromDeploymentRepository(ArtifactMetadata metadata,
                                                         ArtifactRepository remoteRepository,
                                                         java.io.File file,
                                                         java.lang.String checksumPolicyWarn)
                                                           throws TransferFailedException,
                                                                  ResourceDoesNotExistException

      Throws:
        `TransferFailedException`
        `ResourceDoesNotExistException`

    - #### setOnline

          void setOnline(boolean online)

    - #### isOnline

          boolean isOnline()

    - #### addProxy

          void addProxy(java.lang.String protocol,
                      java.lang.String host,
                      int port,
                      java.lang.String username,
                      java.lang.String password,
                      java.lang.String nonProxyHosts)

    - #### addAuthenticationInfo

          void addAuthenticationInfo(java.lang.String repositoryId,
                                   java.lang.String username,
                                   java.lang.String password,
                                   java.lang.String privateKey,
                                   java.lang.String passphrase)

    - #### addMirror

          void addMirror(java.lang.String id,
                       java.lang.String mirrorOf,
                       java.lang.String url)

    - #### setDownloadMonitor

          void setDownloadMonitor(TransferListener downloadMonitor)

    - #### addPermissionInfo

          void addPermissionInfo(java.lang.String repositoryId,
                               java.lang.String filePermissions,
                               java.lang.String directoryPermissions)

    - #### getProxy

          ProxyInfo getProxy(java.lang.String protocol)

    - #### getAuthenticationInfo

          AuthenticationInfo getAuthenticationInfo(java.lang.String id)

    - #### addConfiguration

          void addConfiguration(java.lang.String repositoryId,
                              Xpp3Dom configuration)

      Set the configuration for a repository
      Parameters:
        `repositoryId` - id of the repository to set the configuration to
        `configuration` - dom tree of the xml with the configuration for the `Wagon`

    - #### setInteractive

          void setInteractive(boolean interactive)

    - #### registerWagons

          void registerWagons(java.util.Collection wagons,
                            PlexusContainer extensionContainer)

    - #### setDefaultRepositoryPermissions

          void setDefaultRepositoryPermissions(RepositoryPermissions permissions)

    - #### getMirrorRepository

          ArtifactRepository getMirrorRepository(ArtifactRepository repository)